Index: smf/Packages/installed.list
===================================================================
--- smf/Packages/installed.list	(revision 1047)
+++ smf/Packages/installed.list	(working copy)
@@ -1,2 +1,7 @@
 SMF 1.0.13 / 1.1.5 / 2.0 b3.1 Update|^|smf_patch_1.0.13_1.1.5_2.0-b3.1.zip|^|smf:smf-1.0.13-1.1.5-2.0.b3.1|^|1.0
 Visual Verification Options|^|VisualVerificationOptions_0-5-2.tar.gz|^|motokochan:visualverificationoptions|^|0.5.2
+SMF 1.0.14 / 1.1.6 Update|^|smf_patch_1.0.14_1.1.6.zip|^|smf:smf-1.0.14-1.1.6|^|1.0
+SMF 1.0.15 / 1.1.7 Update|^|smf_patch_1.0.15_1.1.7.zip|^|smf:smf-1.0.15-1.1.7|^|1.0
+SMF 1.0.16 / 1.1.8 Update|^|smf_patch_1.0.16_1.1.8.zip|^|smf:smf-1.1.8|^|1.0
+SMF 1.0.17 / 1.1.9 / 2.0 RC1 Update|^|smf_patch_1.0.17_1.1.9_2.0-RC1-1.zip|^|smf:smf-1.1.9|^|1.0
+SMF 1.0.18 / 1.1.10 / 2.0 RC1-2 Update|^|smf_patch_1.0.18_1.1.10-2.0-RC1.2.zip|^|smf:smf-1.1.10|^|1.1
Index: smf/SSI.php
===================================================================
--- smf/SSI.php	(revision 1047)
+++ smf/SSI.php	(working copy)
@@ -5,7 +5,7 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.5                                           *
+* Software Version:           SMF 1.1.7                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
 * Copyright 2006 by:          Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
@@ -95,6 +95,10 @@
 // Clean the request variables.
 cleanRequest();
 
+// Seed the random generator?
+if (empty($modSettings['rand_seed']) || mt_rand(1, 250) == 69)
+	smf_seed_generator();
+
 // Check on any hacking attempts.
 if (isset($_REQUEST['GLOBALS']) || isset($_COOKIE['GLOBALS']))
 	die('Hacking attempt...');
@@ -102,11 +106,8 @@
 	die('Hacking attempt...');
 elseif (isset($_COOKIE['ssi_theme']) && (int) $_COOKIE['ssi_theme'] == (int) $ssi_theme)
 	die('Hacking attempt...');
-elseif (isset($_REQUEST['ssi_layers']))
-{
-	if ((@get_magic_quotes_gpc() ? addslashes($_REQUEST['ssi_layers']) : $_REQUEST['ssi_layers']) == htmlspecialchars($ssi_layers))
-		die('Hacking attempt...');
-}
+elseif (isset($_REQUEST['ssi_layers'], $ssi_layers) && (@get_magic_quotes_gpc() ? stripslashes($_REQUEST['ssi_layers']) : $_REQUEST['ssi_layers']) == $ssi_layers)
+	die('Hacking attempt...');
 if (isset($_REQUEST['context']))
 	die('Hacking attempt...');
 
Index: smf/Sources/Admin.php
===================================================================
--- smf/Sources/Admin.php	(revision 1047)
+++ smf/Sources/Admin.php	(working copy)
@@ -5,7 +5,7 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.5                                           *
+* Software Version:           SMF 1.1.6                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
 * Copyright 2006 by:          Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
@@ -122,7 +122,7 @@
 function Admin()
 {
 	global $sourcedir, $db_prefix, $forum_version, $txt, $scripturl, $context, $modSettings;
-	global $user_info, $_PHPA, $boardurl;
+	global $user_info, $_PHPA, $boardurl, $memcached;
 
 	if (isset($_GET['area']) && $_GET['area'] == 'copyright')
 		return ManageCopyright();
@@ -231,6 +231,10 @@
 	list ($context['current_versions']['mysql']['version']) = mysql_fetch_row($request);
 	mysql_free_result($request);
 
+	// If we're using memcache we need the server info.
+	if (empty($memcached) && function_exists('memcache_get') && isset($modSettings['cache_memcached']) && trim($modSettings['cache_memcached']) != '')
+		get_memcached_server();
+
 	// Check to see if we have any accelerators installed...
 	if (defined('MMCACHE_VERSION'))
 		$context['current_versions']['mmcache'] = array('title' => 'Turck MMCache', 'version' => MMCACHE_VERSION);
@@ -241,7 +245,7 @@
 	if (extension_loaded('apc'))
 		$context['current_versions']['apc'] = array('title' => 'Alternative PHP Cache', 'version' => phpversion('apc'));
 	if (function_exists('memcache_set'))
-		$context['current_versions']['memcache'] = array('title' => 'Memcached', 'version' => memcache_get_version());
+		$context['current_versions']['memcache'] = array('title' => 'Memcached', 'version' => empty($memcached) ? '???' : memcache_get_version($memcached));
 
 	$context['can_admin'] = allowedTo('admin_forum');
 
Index: smf/Sources/Display.php
===================================================================
--- smf/Sources/Display.php	(revision 1047)
+++ smf/Sources/Display.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.4                                           *
+* Software Version:           SMF 1.1.9                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -702,7 +702,7 @@
 		{
 			$request = db_query("
 				SELECT
-					a.ID_ATTACH, a.ID_MSG, a.filename, IFNULL(a.size, 0) AS filesize, a.downloads,
+					a.ID_ATTACH, a.ID_MSG, a.filename, a.file_hash, IFNULL(a.size, 0) AS filesize, a.downloads,
 					a.width, a.height" . (empty($modSettings['attachmentShowImages']) || empty($modSettings['attachmentThumbnails']) ? '' : ",
 					IFNULL(thumb.ID_ATTACH, 0) AS ID_THUMB, thumb.width AS thumb_width, thumb.height AS thumb_height") . "
 				FROM {$db_prefix}attachments AS a" . (empty($modSettings['attachmentShowImages']) || empty($modSettings['attachmentThumbnails']) ? '' : "
@@ -941,7 +941,7 @@
 	if (isset($_REQUEST['type']) && $_REQUEST['type'] == 'avatar')
 	{
 		$request = db_query("
-			SELECT filename, ID_ATTACH, attachmentType
+			SELECT filename, ID_ATTACH, attachmentType, file_hash
 			FROM {$db_prefix}attachments
 			WHERE ID_ATTACH = $_REQUEST[attach]
 				AND ID_MEMBER > 0
@@ -955,7 +955,7 @@
 
 		// Make sure this attachment is on this board.
 		$request = db_query("
-			SELECT a.filename, a.ID_ATTACH, a.attachmentType
+			SELECT a.filename, a.ID_ATTACH, a.attachmentType, a.file_hash
 			FROM ({$db_prefix}boards AS b, {$db_prefix}messages AS m, {$db_prefix}attachments AS a)
 			WHERE b.ID_BOARD = m.ID_BOARD
 				AND $user_info[query_see_board]
@@ -965,7 +965,7 @@
 	}
 	if (mysql_num_rows($request) == 0)
 		fatal_lang_error(1, false);
-	list ($real_filename, $ID_ATTACH, $attachmentType) = mysql_fetch_row($request);
+	list ($real_filename, $ID_ATTACH, $attachmentType, $file_hash) = mysql_fetch_row($request);
 	mysql_free_result($request);
 
 	// Update the download counter (unless it's a thumbnail).
@@ -976,7 +976,7 @@
 			WHERE ID_ATTACH = $ID_ATTACH
 			LIMIT 1", __FILE__, __LINE__);
 
-	$filename = getAttachmentFilename($real_filename, $_REQUEST['attach']);
+	$filename = getAttachmentFilename($real_filename, $_REQUEST['attach'], false, $file_hash);
 
 	// This is done to clear any output that was made before now. (would use ob_clean(), but that's PHP 4.2.0+...)
 	ob_end_clean();
@@ -1036,7 +1036,11 @@
 	header('Connection: close');
 	header('ETag: ' . $file_md5);
 
-	if (filesize($filename) != 0)
+	// IE 6 just doesn't play nice. As dirty as this seems, it works.
+	if ($context['browser']['is_ie6'] && isset($_REQUEST['image']))
+		unset($_REQUEST['image']);
+
+	elseif (filesize($filename) != 0)
 	{
 		$size = @getimagesize($filename);
 		if (!empty($size))
@@ -1047,7 +1051,7 @@
 				2 => 'jpeg',
 				3 => 'png',
 				5 => 'psd',
-				6 => 'bmp',
+				6 => 'x-ms-bmp',
 				7 => 'tiff',
 				8 => 'tiff',
 				9 => 'jpeg',
@@ -1055,8 +1059,8 @@
 			);
 
 			// Do we have a mime type we can simpy use?
-			if (!empty($size['mime']))
-				header('Content-Type: ' . $size['mime']);
+			if (!empty($size['mime']) && !in_array($size[2], array(4, 13)))
+				header('Content-Type: ' . strtr($size['mime'], array('image/bmp' => 'image/x-ms-bmp')));
 			elseif (isset($validTypes[$size[2]]))
 				header('Content-Type: image/' . $validTypes[$size[2]]);
 			// Otherwise - let's think safety first... it might not be an image...
@@ -1068,11 +1072,9 @@
 			unset($_REQUEST['image']);
 	}
 
+	header('Content-Disposition: ' . (isset($_REQUEST['image']) ? 'inline' : 'attachment') . '; filename="' . $real_filename . '"');
 	if (!isset($_REQUEST['image']))
-	{
-		header('Content-Disposition: attachment; filename="' . $real_filename . '"');
 		header('Content-Type: application/octet-stream');
-	}
 
 	// If this has an "image extension" - but isn't actually an image - then ensure it isn't cached cause of silly IE.
 	if (!isset($_REQUEST['image']) && in_array(substr($real_filename, -4), array('.gif', '.jpg', '.bmp', '.png', 'jpeg', 'tiff')))
@@ -1166,7 +1168,7 @@
 				// A proper thumb doesn't exist yet? Create one!
 				if (empty($attachment['ID_THUMB']) || $attachment['thumb_width'] > $modSettings['attachmentThumbWidth'] || $attachment['thumb_height'] > $modSettings['attachmentThumbHeight'] || ($attachment['thumb_width'] < $modSettings['attachmentThumbWidth'] && $attachment['thumb_height'] < $modSettings['attachmentThumbHeight']))
 				{
-					$filename = getAttachmentFilename($attachment['filename'], $attachment['ID_ATTACH']);
+					$filename = getAttachmentFilename($attachment['filename'], $attachment['ID_ATTACH'], false, $attachment['file_hash']);
 
 					require_once($sourcedir . '/Subs-Graphics.php');
 					if (createThumbnail($filename, $modSettings['attachmentThumbWidth'], $modSettings['attachmentThumbHeight']))
@@ -1178,10 +1180,11 @@
 						$thumb_filename = addslashes($attachment['filename'] . '_thumb');
 
 						// Add this beauty to the database.
+						$thumb_hash = getAttachmentFilename($thumb_filename, false, true);
 						db_query("
 							INSERT INTO {$db_prefix}attachments
-								(ID_MSG, attachmentType, filename, size, width, height)
-							VALUES ($ID_MSG, 3, '$thumb_filename', " . (int) $thumb_size . ", " . (int) $attachment['thumb_width'] . ", " . (int) $attachment['thumb_height'] . ")", __FILE__, __LINE__);
+								(ID_MSG, attachmentType, filename, file_hash, size, width, height)
+							VALUES ($ID_MSG, 3, '$thumb_filename', '$thumb_hash', " . (int) $thumb_size . ", " . (int) $attachment['thumb_width'] . ", " . (int) $attachment['thumb_height'] . ")", __FILE__, __LINE__);
 						$attachment['ID_THUMB'] = db_insert_id();
 						if (!empty($attachment['ID_THUMB']))
 						{
@@ -1191,8 +1194,8 @@
 								WHERE ID_ATTACH = $attachment[ID_ATTACH]
 								LIMIT 1", __FILE__, __LINE__);
 
-							$thumb_realname = getAttachmentFilename($thumb_filename, $attachment['ID_THUMB'], true);
-							rename($filename . '_thumb', $modSettings['attachmentUploadDir'] . '/' . $thumb_realname);
+							$thumb_realname = getAttachmentFilename($thumb_filename, $attachment['ID_THUMB'], false, $thumb_hash);
+							rename($filename . '_thumb', $thumb_realname);
 						}
 					}
 				}
Index: smf/Sources/Help.php
===================================================================
--- smf/Sources/Help.php	(revision 1047)
+++ smf/Sources/Help.php	(working copy)
@@ -62,7 +62,7 @@
 		'searching' => 'search',
 	);
 
-	if (!isset($_GET['page']) || !isset($context['all_pages'][$_GET['page']]))
+	if (!isset($_GET['page']) || !is_string($_GET['page']) || !isset($context['all_pages'][$_GET['page']]))
 		$_GET['page'] = 'index';
 
 	$context['current_page'] = $_GET['page'];
Index: smf/Sources/Load.php
===================================================================
--- smf/Sources/Load.php	(revision 1047)
+++ smf/Sources/Load.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.5                                           *
+* Software Version:           SMF 1.1.9                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -1178,6 +1178,10 @@
 		// Pick between $settings and $options depending on whose data it is.
 		while ($row = mysql_fetch_assoc($result))
 		{
+			// There are just things we shouldn't be able to change as members.
+			if ($row['ID_MEMBER'] != 0 && in_array($row['variable'], array('actual_theme_url', 'actual_images_url', 'base_theme_dir', 'base_theme_url', 'default_images_url', 'default_theme_dir', 'default_theme_url', 'default_template', 'images_url', 'number_recent_posts', 'smiley_sets_default', 'theme_dir', 'theme_id', 'theme_layers', 'theme_templates', 'theme_url')))
+				continue;
+
 			// If this is the theme_dir of the default theme, store it.
 			if (in_array($row['variable'], array('theme_dir', 'theme_url', 'images_url')) && $row['ID_THEME'] == '1' && empty($row['ID_MEMBER']))
 				$themeData[0]['default_' . $row['variable']] = $row['value'];
@@ -1941,9 +1945,9 @@
 		// This is here to stop people from using bad junky PHPSESSIDs.
 		if (isset($_REQUEST[session_name()]) && preg_match('~^[A-Za-z0-9]{16,32}$~', $_REQUEST[session_name()]) == 0 && !isset($_COOKIE[session_name()]))
 		{
-			$_REQUEST[session_name()] = md5(md5('smf_sess_' . time()) . rand());
-			$_GET[session_name()] = md5(md5('smf_sess_' . time()) . rand());
-			$_POST[session_name()] = md5(md5('smf_sess_' . time()) . rand());
+			$_REQUEST[session_name()] = md5(md5('smf_sess_' . time()) . mt_rand());
+			$_GET[session_name()] = md5(md5('smf_sess_' . time()) . mt_rand());
+			$_POST[session_name()] = md5(md5('smf_sess_' . time()) . mt_rand());
 		}
 
 		// Use database sessions? (they don't work in 4.1.x!)
@@ -1970,16 +1974,21 @@
 		if (!empty($modSettings['databaseSession_loose']))
 			header('Cache-Control: private');
 	}
-
-	// While PHP 4.1.x should use $_SESSION, it seems to need this to do it right.
-	if (@version_compare(PHP_VERSION, '4.2.0') == -1)
-		$HTTP_SESSION_VARS['php_412_bugfix'] = true;
 	*/
 
 	// Set the randomly generated code.
 	if (!isset($_SESSION['rand_code']))
-		$_SESSION['rand_code'] = md5(session_id() . rand());
+		$_SESSION['rand_code'] = md5(session_id() . mt_rand() . (string) microtime() . $modSettings['rand_seed']);
 	$sc = $_SESSION['rand_code'];
+
+	// While PHP 4.1.x should use $_SESSION, it seems to need this to do it right. Also reseed the random generator.
+	if (@version_compare(PHP_VERSION, '4.2.0') == -1)
+	{
+		$HTTP_SESSION_VARS['php_412_bugfix'] = true;
+		mt_srand((float) microtime() * 10000010 + $modSettings['rand_seed']);
+	}
+	else
+		mt_srand();
 }
 
 function sessionOpen($save_path, $session_name)
@@ -2110,7 +2119,7 @@
 	// eAccelerator...
 	elseif (function_exists('eaccelerator_put'))
 	{
-		if (rand(0, 10) == 1)
+		if (mt_rand(0, 10) == 1)
 			eaccelerator_gc();
 
 		if ($value === null)
@@ -2121,7 +2130,7 @@
 	// Turck MMCache?
 	elseif (function_exists('mmcache_put'))
 	{
-		if (rand(0, 10) == 1)
+		if (mt_rand(0, 10) == 1)
 			mmcache_gc();
 
 		if ($value === null)
Index: smf/Sources/LogInOut.php
===================================================================
--- smf/Sources/LogInOut.php	(revision 1047)
+++ smf/Sources/LogInOut.php	(working copy)
@@ -5,7 +5,7 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.3                                           *
+* Software Version:           SMF 1.1.6                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
 * Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
@@ -106,7 +106,7 @@
 		else
 			trigger_error('Login2(): Cannot be logged in without a session or cookie', E_USER_ERROR);
 
-		$user_settings['passwordSalt'] = substr(md5(rand()), 0, 4);
+		$user_settings['passwordSalt'] = substr(md5(mt_rand()), 0, 4);
 		updateMemberData($ID_MEMBER, array('passwordSalt' => '\'' . $user_settings['passwordSalt'] . '\''));
 
 		setLoginCookie($timeout - time(), $ID_MEMBER, sha1($user_settings['passwd'] . $user_settings['passwordSalt']));
@@ -347,7 +347,7 @@
 		if (in_array($user_settings['passwd'], $other_passwords))
 		{
 			$user_settings['passwd'] = $sha_passwd;
-			$user_settings['passwordSalt'] = substr(md5(rand()), 0, 4);
+			$user_settings['passwordSalt'] = substr(md5(mt_rand()), 0, 4);
 
 			// Update the password and set up the hash.
 			updateMemberData($user_settings['ID_MEMBER'], array('passwd' => '\'' . $user_settings['passwd'] . '\'', 'passwordSalt' => '\'' . $user_settings['passwordSalt'] . '\''));
@@ -375,7 +375,7 @@
 	// Correct password, but they've got no salt; fix it!
 	elseif ($user_settings['passwordSalt'] == '')
 	{
-		$user_settings['passwordSalt'] = substr(md5(rand()), 0, 4);
+		$user_settings['passwordSalt'] = substr(md5(mt_rand()), 0, 4);
 		updateMemberData($user_settings['ID_MEMBER'], array('passwordSalt' => '\'' . $user_settings['passwordSalt'] . '\''));
 	}
 
Index: smf/Sources/ManageAttachments.php
===================================================================
--- smf/Sources/ManageAttachments.php	(revision 1047)
+++ smf/Sources/ManageAttachments.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.4                                           *
+* Software Version:           SMF 1.1.10                                          *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006 by:          Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -161,7 +161,6 @@
 			'attachmentCheckExtensions' => empty($_POST['attachmentCheckExtensions']) ? '0' : '1',
 			'attachmentExtensions' => $_POST['attachmentExtensions'],
 			'attachmentShowImages' => empty($_POST['attachmentShowImages']) ? '0' : '1',
-			'attachmentEncryptFilenames' => empty($_POST['attachmentEncryptFilenames']) ? '0' : '1',
 			'attachmentUploadDir' => $_POST['attachmentUploadDir'],
 			'attachmentDirSizeLimit' => (int) $_POST['attachmentDirSizeLimit'],
 			'attachmentPostLimit' => (int) $_POST['attachmentPostLimit'],
@@ -339,7 +338,7 @@
 				'name' => htmlspecialchars($row['filename']),
 				'downloads' => $row['downloads'],
 				'href' => $row['attachmentType'] == 1 ? $modSettings['custom_avatar_url'] . '/' . $row['filename'] : ($scripturl . '?action=dlattach;' . ($context['browse_type'] == 'avatars' ? 'type=avatar;' : 'topic=' . $row['ID_TOPIC'] . '.0;') . 'id=' . $row['ID_ATTACH']),
-				'link' => '<a href="' . ($row['attachmentType'] == 1 ? $modSettings['custom_avatar_url'] . '/' . $row['filename'] : ($scripturl . '?action=dlattach;' . ($context['browse_type'] == 'avatars' ? 'type=avatar;' : 'topic=' . $row['ID_TOPIC'] . '.0;') . 'id=' . $row['ID_ATTACH'])) . '"' . (empty($row['width']) || empty($row['height']) ? '' : ' onclick="return reqWin(this.href + \';image\', ' . ($row['width'] + 20) . ', ' . ($row['height'] + 20) . ', true);"') . '>' . htmlspecialchars($row['filename']) . '</a>'
+				'link' => '<a href="' . ($row['attachmentType'] == 1 ? $modSettings['custom_avatar_url'] . '/' . $row['filename'] : ($scripturl . '?action=dlattach;' . ($context['browse_type'] == 'avatars' ? 'type=avatar;' : 'topic=' . $row['ID_TOPIC'] . '.0;') . 'id=' . $row['ID_ATTACH'])) . '"' . (empty($row['width']) || empty($row['height']) ? '' : ' onclick="return reqWin(this.href + \'' . ($modSettings['custom_avatar_url'] ? '' : ';image') . '\', ' . ($row['width'] + 20) . ', ' . ($row['height'] + 20) . ', true);"') . '>' . htmlspecialchars($row['filename']) . '</a>'
 			),
 			'topic' => $row['ID_TOPIC'],
 			'subject' => $row['subject'],
@@ -419,14 +418,14 @@
 	}
 
 	$request = db_query("
-		SELECT ID_ATTACH, ID_MEMBER, filename
+		SELECT ID_ATTACH, ID_MEMBER, filename, file_hash
 		FROM {$db_prefix}attachments
 		WHERE attachmentType = 0
 			AND ID_MEMBER > 0", __FILE__, __LINE__);
 	$updatedAvatars = array();
 	while ($row = mysql_fetch_assoc($request))
 	{
-		$filename = getAttachmentFilename($row['filename'], $row['ID_ATTACH']);
+		$filename = getAttachmentFilename($row['filename'], $row['ID_ATTACH'], false, $row['file_hash']);
 
 		if (rename($filename, $modSettings['custom_avatar_dir'] . '/' . $row['filename']))
 			$updatedAvatars[] = $row['ID_ATTACH'];
@@ -561,7 +560,7 @@
 	// Get all the attachment names and ID_MSGs.
 	$request = db_query("
 		SELECT
-			a.filename, a.attachmentType, a.ID_ATTACH, a.ID_MEMBER" . ($query_type == 'messages' ? ', m.ID_MSG' : ', a.ID_MSG') . ",
+			a.filename, a.file_hash, a.attachmentType, a.ID_ATTACH, a.ID_MEMBER" . ($query_type == 'messages' ? ', m.ID_MSG' : ', a.ID_MSG') . ",
 			IFNULL(thumb.ID_ATTACH, 0) AS ID_THUMB, thumb.filename AS thumb_filename, thumb_parent.ID_ATTACH AS ID_PARENT
 		FROM ({$db_prefix}attachments AS a" .($query_type == 'members' ? ", {$db_prefix}members AS mem" : ($query_type == 'messages' ? ", {$db_prefix}messages AS m" : '')) . ")
 			LEFT JOIN {$db_prefix}attachments AS thumb ON (thumb.ID_ATTACH = a.ID_THUMB)
@@ -576,7 +575,7 @@
 			@unlink($modSettings['custom_avatar_dir'] . '/' . $row['filename']);
 		else
 		{
-			$filename = getAttachmentFilename($row['filename'], $row['ID_ATTACH']);
+			$filename = getAttachmentFilename($row['filename'], $row['ID_ATTACH'], false, $row['file_hash']);
 			@unlink($filename);
 
 			// If this was a thumb, the parent attachment should know about it.
@@ -586,7 +585,7 @@
 			// If this attachments has a thumb, remove it as well.
 			if (!empty($row['ID_THUMB']) && $autoThumbRemoval)
 			{
-				$thumb_filename = getAttachmentFilename($row['thumb_filename'], $row['ID_THUMB']);
+				$thumb_filename = getAttachmentFilename($row['thumb_filename'], $row['ID_THUMB'], false, $row['file_hash']);
 				@unlink($thumb_filename);
 				$attach[] = $row['ID_THUMB'];
 			}
@@ -690,7 +689,7 @@
 			$to_remove = array();
 
 			$result = db_query("
-				SELECT thumb.ID_ATTACH, thumb.filename
+				SELECT thumb.ID_ATTACH, thumb.filename, thumb.file_hash
 				FROM {$db_prefix}attachments AS thumb
 					LEFT JOIN {$db_prefix}attachments AS tparent ON (tparent.ID_THUMB = thumb.ID_ATTACH)
 				WHERE thumb.ID_ATTACH BETWEEN $_GET[substep] AND $_GET[substep] + 499
@@ -705,7 +704,7 @@
 				// If we are repairing remove the file from disk now.
 				if ($fix_errors && in_array('missing_thumbnail_parent', $to_fix))
 				{
-					$filename = getAttachmentFilename($row['filename'], $row['ID_ATTACH']);
+					$filename = getAttachmentFilename($row['filename'], $row['ID_ATTACH'], false, $row['file_hash']);
 					@unlink($filename);
 				}
 			}
@@ -788,7 +787,7 @@
 			$errors_found = array();
 
 			$result = db_query("
-				SELECT ID_ATTACH, filename, size, attachmentType
+				SELECT ID_ATTACH, filename, file_hash, size, attachmentType
 				FROM {$db_prefix}attachments
 				WHERE ID_ATTACH BETWEEN $_GET[substep] AND $_GET[substep] + 249", __FILE__, __LINE__);
 			while ($row = mysql_fetch_assoc($result))
@@ -797,7 +796,7 @@
 				if ($row['attachmentType'] == 1)
 					$filename = $modSettings['custom_avatar_dir'] . '/' . $row['filename'];
 				else
-					$filename = getAttachmentFilename($row['filename'], $row['ID_ATTACH']);
+					$filename = getAttachmentFilename($row['filename'], $row['ID_ATTACH'], false, $row['file_hash']);
 
 				// File doesn't exist?
 				if (!file_exists($filename))
@@ -882,7 +881,7 @@
 			$to_remove = array();
 
 			$result = db_query("
-				SELECT a.ID_ATTACH, a.filename, a.attachmentType
+				SELECT a.ID_ATTACH, a.filename, a.file_hash, a.attachmentType
 				FROM {$db_prefix}attachments AS a
 					LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = a.ID_MEMBER)
 				WHERE a.ID_ATTACH BETWEEN $_GET[substep] AND $_GET[substep] + 499
@@ -900,7 +899,7 @@
 					if ($row['attachmentType'] == 1)
 						$filename = $modSettings['custom_avatar_dir'] . '/' . $row['filename'];
 					else
-						$filename = getAttachmentFilename($row['filename'], $row['ID_ATTACH']);
+						$filename = getAttachmentFilename($row['filename'], $row['ID_ATTACH'], false, $row['file_hash']);
 					@unlink($filename);
 				}
 			}
@@ -938,7 +937,7 @@
 			$to_remove = array();
 
 			$result = db_query("
-				SELECT a.ID_ATTACH, a.filename
+				SELECT a.ID_ATTACH, a.filename, a.file_hash
 				FROM {$db_prefix}attachments AS a
 					LEFT JOIN {$db_prefix}messages AS m ON (m.ID_MSG = a.ID_MSG)
 				WHERE a.ID_ATTACH BETWEEN $_GET[substep] AND $_GET[substep] + 499
@@ -953,7 +952,7 @@
 				// If we are repairing remove the file from disk now.
 				if ($fix_errors && in_array('attachment_no_msg', $to_fix))
 				{
-					$filename = getAttachmentFilename($row['filename'], $row['ID_ATTACH']);
+					$filename = getAttachmentFilename($row['filename'], $row['ID_ATTACH'], false, $row['file_hash']);
 					@unlink($filename);
 				}
 			}
Index: smf/Sources/ManageBans.php
===================================================================
--- smf/Sources/ManageBans.php	(revision 1047)
+++ smf/Sources/ManageBans.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1                                             *
+* Software Version:           SMF 1.1.10                                          *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006 by:          Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -1176,6 +1176,9 @@
 	if (!empty($updates))
 		foreach ($updates as $newStatus => $members)
 			updateMemberData($members, array('is_activated' => $newStatus));
+
+	// Update the amount of members awaiting approval
+	updateStats('member');
 }
 
 ?>
\ No newline at end of file
Index: smf/Sources/ManageMembers.php
===================================================================
--- smf/Sources/ManageMembers.php	(revision 1047)
+++ smf/Sources/ManageMembers.php	(working copy)
@@ -5,7 +5,7 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1                                             *
+* Software Version:           SMF 1.1.6                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
 * Copyright 2006 by:          Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
@@ -766,7 +766,7 @@
 
 				sendmail($member['email'], $txt['register_subject'],
 					"$txt[hello_guest] $member[name]!\n\n" .
-					"$txt[admin_approve_accept_desc] $txt[719] $member[name]\n\n" .
+					"$txt[admin_approve_accept_desc] $txt[719] $member[username]\n\n" .
 					"$txt[701]\n" .
 					"$scripturl?action=profile\n\n" .
 					$txt[130]);
@@ -776,11 +776,13 @@
 	// Maybe we're sending it off for activation?
 	elseif ($_POST['todo'] == 'require_activation')
 	{
+		require_once($sourcedir . '/Subs-Members.php');
+
 		// We have to do this for each member I'm afraid.
 		foreach ($member_info as $member)
 		{
 			// Generate a random activation code.
-			$validation_code = substr(preg_replace('/\W/', '', md5(rand())), 0, 10);
+			$validation_code = generateValidationCode();
 
 			// Set these members for activation - I know this includes two ID_MEMBER checks but it's safer than bodging $condition ;).
 			db_query("
